// Full Name: 
// User ID: 
// Approximate number of hours spent on this assignment: 
import java.util.Arrays;

public class ArrayTester
{
    private static final int MAX_VALUES = 10;  // the maximum number of elements that can be stored
    private int[] intArr;
    private int numValues;  // the number of valid array elements
    
    
    // default constructor
    public ArrayTester()
    {
        intArr = new int[MAX_VALUES];
        numValues = 0;
    }
    
    // construct an ArrayTester object from an array of ints, a;
    // if there are more elements in a than MAX_VALUES, store only
    // the first MAX_VALUES elements from a in intArr, the array instance variable
    // HINT1: use a.length to determine how many elements are in array a
    // HINT2: make sure you update numValues
    public ArrayTester(int[] a)
    {
        intArr = new int[MAX_VALUES];
        if (a.length <= MAX_VALUES)
            numValues = a.length;
        else
            numValues = MAX_VALUES;
        for (int i = 0; i < numValues; i++)
            intArr[i] = a[i];
    }
    
    // constructs an ArrayTester object with a specified number (numRandom)
    // of random integers in the range [-10..15], the average low temperature
    // range in Pittsburgh over a year;
    // if numRandom is greater than MAX_VALUES, store only MAX_VALUES random numbers in intArr
    // HINT: first create an array of the appropriate length, then set the values
    public ArrayTester(int numRandom)
    {
        // your code goes here
    }
    
    // adds a new integer, i, to the end of the current elements
    // in the array and adjusts numValues accordingly;
    // e.g., if the array contained 12, 4, 5 and this method
    // was called to insert 13, the array would ultimately contain
    // 12, 4, 5, 13 and numValues would be 4.
    // If there are already MAX_VALUES in the array, it
    // should NOT add the new integer, but print an error
    // message.  It should NOT cause a run-time error!
    public void insertLast(int i)
    {
        // your code goes here
    }
    
    // checks if the array is sorted in increasing order
    // i.e., a[i] <= a[i+1] for all valid array elements and
    // returns true if it is, false otherwise
    public boolean isIncreasing()
    {
        return false;  // replace this with your code
    }
    
    // returns the maximum value in the array;
    // returns Integer.MIN_VALUE if the array is empty
    public int maximum()
    {
        return 0;  // replace this with your code
    }
    
    // searches the array to see if a given value (the key)
    // is present.  Returns the index of the last occurrence
    // of the value in the array or -1 if the value is not present
    public int lastIndex(int key)
    {
        return -1;  // replace this with your code
    }
    
    // searches the array to see if the given value (the key)
    // is present more than once.  Returns true if so, false otherwise
    public boolean duplicate(int key)
    {
        return false;  // replace this with your code
    }
    
    // rotates all the elements one position to the left, placing the element
    // that was in position 0 into the last occupied cell of the array
    // Example:  if the array before the call to rotateLeft is 1, 4, 5, 6
    // it is 4, 5, 6, 1 after the call
    public void rotateLeft()
    {
        
    }
    
    // reverses the elements stored in the array
    // Example: if the array before the call to reverse is 1, 4, 5, 6
    // it is 6, 5, 4, 1 after the call
    public void reverse()
    {
        for (int i = 0; i < numValues/2; i++)
        {
            //can't call swap(intArr[i],intArr[numValues-i-1]) since values are passed
            swap(intArr,i,numValues-i-1);
        }
        
    }
    
    private void swap(int[] arr, int index1, int index2)
    {
        int temp = arr[index1];
        arr[index1] = arr[index2];
        arr[index2] = temp;
    }
    
    // to override Object's toString, name and parameters must match Object's toString method
    // Returns a String representing all the attributes of this ArrayTester
    public String toString()
    {
        return numValues + " valid values: " + Arrays.toString(intArr);
    }
    
    
    public static void main(String[] args)
    {
        ArrayTester a = new ArrayTester();
        int[] arr = {1,2,3,4,5};
        System.out.println(arr.length);
        ArrayTester anotherArray = new ArrayTester(arr);
        // your code goes here to call AND test
        // each of the above methods...
        System.out.println(anotherArray);
        anotherArray.reverse();
        System.out.println(anotherArray);
    }
}
